import { select, range, scaleOrdinal } from "d3";

const svg = select("svg");
	
//parseFloat() maakt van een string een nummer
//parseFloat() schrijf je in het kort met '+'
const width = +svg.attr("width");
const height = +svg.attr("height");

const colorScale = scaleOrdinal()
	.domain(['apple', 'lemon'])
	.range(['#c11d1d', '#eae600']);

const radiusScale = scaleOrdinal()
	.domain(['apple', 'lemon'])
	.range([50, 30]);

const render = (selection, {fruits}) => {
  //met enter vul je hier de array fruits met circels
	const circles = selection.selectAll('circle')
  	.data(fruits);
  
  	circles
		.enter().append('circle')
    	//d = data, i = index
			.attr('cx', (d, i) => i * 120 + 60)
			.attr('cy', height / 2);
  	//door circles te gebruiken, wordt 'update' gebruikt
  	circles
			.attr('r', d => radiusScale(d.type))
			.attr('fill', d => colorScale(d.type));
  
    circles
    	//exit haalt alles uit de DOM wat niet 'gevuld' is
      .exit().remove();
}

const makeFruit = type => ({type});
//range() maakt een array en met .map loop je hier doorheen
const fruits = range(5)
	.map(() => makeFruit("apple"));

render(svg, {fruits});

//een appel eten, pop() haalt er eentje weg
setTimeout(() => {
	fruits.pop();
	render(svg, {fruits});
}, 1000)

//een appel vervangen door een citroen
setTimeout(() => {
	fruits[2].type = 'lemon';
	render(svg, {fruits});
}, 2000)



